Index: code/branches/pickup2/src/orxonox/CMakeLists.txt
===================================================================
--- code/branches/pickup2/src/orxonox/CMakeLists.txt	(revision 6405)
+++ code/branches/pickup2/src/orxonox/CMakeLists.txt	(revision 6412)
@@ -28,4 +28,5 @@
   LevelManager.cc
   Main.cc
+  MoodManager.cc
   PawnManager.cc
   PlayerManager.cc
@@ -54,4 +55,7 @@
   TOLUA_FILES
     LevelManager.h
+    MoodManager.h
+    controllers/HumanController.h
+    sound/SoundManager.h
   DEFINE_SYMBOL
     "ORXONOX_SHARED_BUILD"
Index: code/branches/pickup2/src/orxonox/CameraManager.cc
===================================================================
--- code/branches/pickup2/src/orxonox/CameraManager.cc	(revision 6405)
+++ code/branches/pickup2/src/orxonox/CameraManager.cc	(revision 6412)
@@ -45,5 +45,4 @@
 namespace orxonox
 {
-    CameraManager* CameraManager::singletonPtr_s = 0;
     ManageScopedSingleton(CameraManager, ScopeID::Graphics, false);
 
Index: code/branches/pickup2/src/orxonox/Level.cc
===================================================================
--- code/branches/pickup2/src/orxonox/Level.cc	(revision 6405)
+++ code/branches/pickup2/src/orxonox/Level.cc	(revision 6412)
@@ -141,5 +141,5 @@
     void Level::playerEntered(PlayerInfo* player)
     {
-        COUT(3) << "player entered level (id: " << player->getClientID() << ", name: " << player->getName() << ")" << std::endl;
+        COUT(3) << "player entered level (id: " << player->getClientID() << ", name: " << player->getName() << ')' << std::endl;
         player->setGametype(this->getGametype());
     }
@@ -147,5 +147,5 @@
     void Level::playerLeft(PlayerInfo* player)
     {
-        COUT(3) << "player left level (id: " << player->getClientID() << ", name: " << player->getName() << ")" << std::endl;
+        COUT(3) << "player left level (id: " << player->getClientID() << ", name: " << player->getName() << ')' << std::endl;
         player->setGametype(0);
     }
Index: code/branches/pickup2/src/orxonox/LevelManager.cc
===================================================================
--- code/branches/pickup2/src/orxonox/LevelManager.cc	(revision 6405)
+++ code/branches/pickup2/src/orxonox/LevelManager.cc	(revision 6412)
@@ -30,10 +30,10 @@
 
 #include <map>
-#include <OgreResourceGroupManager.h>
 
-#include "core/CommandLine.h"
+#include "core/CommandLineParser.h"
 #include "core/ConfigValueIncludes.h"
 #include "core/CoreIncludes.h"
 #include "core/Loader.h"
+#include "core/Resource.h"
 #include "core/ScopedSingletonManager.h"
 #include "PlayerManager.h"
@@ -44,5 +44,4 @@
     SetCommandLineArgument(level, "").shortcut("l").information("Default level file (overrides LevelManager::defaultLevelName_ configValue)");
 
-    LevelManager* LevelManager::singletonPtr_s = 0;
     ManageScopedSingleton(LevelManager, ScopeID::Root, false);
 
@@ -53,7 +52,7 @@
 
         // check override
-        if (!CommandLine::getArgument("level")->hasDefaultValue())
+        if (!CommandLineParser::getArgument("level")->hasDefaultValue())
         {
-            ModifyConfigValue(defaultLevelName_, tset, CommandLine::getValue("level").getString());
+            ModifyConfigValue(defaultLevelName_, tset, CommandLineParser::getValue("level").getString());
         }
     }
@@ -66,5 +65,5 @@
     {
         SetConfigValue(defaultLevelName_, "presentation_dm.oxw")
-            .description("Sets the preselection of the level in the main menu.");
+            .description("Sets the pre selection of the level in the main menu.");
     }
 
@@ -123,8 +122,8 @@
     }
 
-    std::string LevelManager::getAvailableLevelListItem(unsigned int index) const
+    const std::string& LevelManager::getAvailableLevelListItem(unsigned int index) const
     {
         if (index >= availableLevels_.size())
-            return std::string();
+            return BLANKSTRING;
         else
             return availableLevels_[index];
@@ -133,9 +132,5 @@
     void LevelManager::compileAvailableLevelList()
     {
-        availableLevels_.clear();
-
-        availableLevels_ = *Ogre::ResourceGroupManager::getSingleton().findResourceNames(
-            Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, "*.oxw");
-
+        availableLevels_ = *Resource::findResourceNames("*.oxw");
         for (std::vector<std::string>::iterator it = availableLevels_.begin(); it != availableLevels_.end();)
             if (it->find("old/") == 0)
Index: code/branches/pickup2/src/orxonox/LevelManager.h
===================================================================
--- code/branches/pickup2/src/orxonox/LevelManager.h	(revision 6405)
+++ code/branches/pickup2/src/orxonox/LevelManager.h	(revision 6412)
@@ -60,5 +60,5 @@
             const std::string& getDefaultLevel() const; //tolua_export
             void compileAvailableLevelList(); //tolua_export
-            std::string getAvailableLevelListItem(unsigned int index) const; //tolua_export
+            const std::string& getAvailableLevelListItem(unsigned int index) const; //tolua_export
 
             static LevelManager* getInstancePtr() { return singletonPtr_s; }
Index: code/branches/pickup2/src/orxonox/Main.cc
===================================================================
--- code/branches/pickup2/src/orxonox/Main.cc	(revision 6405)
+++ code/branches/pickup2/src/orxonox/Main.cc	(revision 6412)
@@ -36,5 +36,5 @@
 #include "OrxonoxPrereqs.h"
 
-#include "core/CommandLine.h"
+#include "core/CommandLineParser.h"
 #include "core/Game.h"
 #include "core/LuaState.h"
@@ -68,7 +68,6 @@
         "  standalone,server,client"
         "   level"
-        " dedicated,dedicatedClient"
+        " server,client"
         "  level"
-        " ioConsole"
         );
 
@@ -76,18 +75,19 @@
 
         // Some development hacks (not really, but in the future, this calls won't make sense anymore)
-        if (CommandLine::getValue("standalone").getBool())
+        if (CommandLineParser::getValue("standalone").getBool())
             Game::getInstance().requestStates("graphics, standalone, level");
-        else if (CommandLine::getValue("server").getBool())
+        else if (CommandLineParser::getValue("server").getBool())
             Game::getInstance().requestStates("graphics, server, level");
-        else if (CommandLine::getValue("client").getBool())
+        else if (CommandLineParser::getValue("client").getBool())
             Game::getInstance().requestStates("graphics, client, level");
-        else if (CommandLine::getValue("dedicated").getBool())
-            Game::getInstance().requestStates("dedicated, level");
-        else if (CommandLine::getValue("dedicatedClient").getBool())
-            Game::getInstance().requestStates("dedicatedClient, level");
-        else if (CommandLine::getValue("console").getBool())
-            Game::getInstance().requestStates("ioConsole");
+        else if (CommandLineParser::getValue("dedicated").getBool())
+            Game::getInstance().requestStates("server, level");
+        else if (CommandLineParser::getValue("dedicatedClient").getBool())
+            Game::getInstance().requestStates("client, level");
         else
-            Game::getInstance().requestStates("graphics, mainMenu");
+        {
+            if (!CommandLineParser::getValue("console").getBool())
+                Game::getInstance().requestStates("graphics, mainMenu");
+        }
 
         game->run();
Index: code/branches/pickup2/src/orxonox/MoodManager.cc
===================================================================
--- code/branches/pickup2/src/orxonox/MoodManager.cc	(revision 6412)
+++ code/branches/pickup2/src/orxonox/MoodManager.cc	(revision 6412)
@@ -0,0 +1,89 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Kevin 'youngk' Young
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "MoodManager.h"
+
+#include "core/ConfigValueIncludes.h"
+#include "core/CoreIncludes.h"
+#include "core/ScopedSingletonManager.h"
+
+namespace orxonox
+{
+    ManageScopedSingleton(MoodManager, ScopeID::Root, false);
+
+    MoodManager::MoodManager()
+    {
+        RegisterRootObject(MoodManager);
+        this->setConfigValues();
+    }
+
+    void MoodManager::setConfigValues()
+    {
+        SetConfigValue(mood_, "default")
+            .description("Sets the mood for the current level.")
+            .callback(this, &MoodManager::checkMoodValidity);
+    }
+
+    /** Sets the mood
+    @note
+        TODO: Inform dependent classes of mood change
+    */
+    void MoodManager::setMood(const std::string& mood)
+    {
+        ModifyConfigValue(mood_, set, mood);
+    }
+
+    void MoodManager::checkMoodValidity()
+    {
+        // TODO: Insert new moods here & make this generic
+        if (mood_ != "default" && mood_ != "dnb")
+        {
+            ResetConfigValue(mood_);
+        }
+        else
+        {
+            COUT(3) << "Mood changed to " << mood_ << std::endl;
+            MoodListener::changedMood(mood_);
+        }
+    }
+
+
+    std::string MoodListener::mood_s;
+
+    MoodListener::MoodListener()
+    {
+        RegisterRootObject(MoodListener);
+    }
+
+    /*static*/ void MoodListener::changedMood(const std::string& mood)
+    {
+        mood_s = mood;
+        for (ObjectList<MoodListener>::iterator it = ObjectList<MoodListener>::begin(); it; ++it)
+            it->moodChanged(mood_s);
+    }
+}
Index: code/branches/pickup2/src/orxonox/MoodManager.h
===================================================================
--- code/branches/pickup2/src/orxonox/MoodManager.h	(revision 6412)
+++ code/branches/pickup2/src/orxonox/MoodManager.h	(revision 6412)
@@ -0,0 +1,81 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Kevin 'youngk' Young
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _MoodManager_H__
+#define _MoodManager_H__
+
+#include "OrxonoxPrereqs.h"
+
+#include <string>
+#include "util/Singleton.h"
+#include "core/OrxonoxClass.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport MoodListener : virtual public OrxonoxClass
+    {
+        friend class MoodManager;
+
+        protected:
+            MoodListener();
+            virtual ~MoodListener() {}
+
+            const std::string& getMood() const { return mood_s; }
+
+        private:
+            virtual void moodChanged(const std::string& mood) = 0;
+
+            static void changedMood(const std::string& mood);
+            static std::string mood_s;
+    };
+
+    class _OrxonoxExport MoodManager : public Singleton<MoodManager>, public OrxonoxClass
+    {
+            friend class Singleton<MoodManager>;
+        public:
+            MoodManager();
+
+            void setConfigValues();
+
+            void setMood(const std::string& mood);
+            inline const std::string& getMood() const { return this->mood_; }
+
+            static MoodManager& getInstance() { return Singleton<MoodManager>::getInstance(); }
+
+        private:
+            ~MoodManager() {}
+            void checkMoodValidity();
+
+            // config values
+            std::string mood_;
+
+            static MoodManager* singletonPtr_s;
+    };
+}
+
+#endif /* _MoodManager_H__ */
Index: code/branches/pickup2/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- code/branches/pickup2/src/orxonox/OrxonoxPrereqs.h	(revision 6405)
+++ code/branches/pickup2/src/orxonox/OrxonoxPrereqs.h	(revision 6412)
@@ -139,5 +139,7 @@
     class AmbientSound;
     class BaseSound;
+    class SoundBuffer;
     class SoundManager;
+    class SoundStreamer;
     class WorldSound;
 
@@ -156,4 +158,5 @@
     class CameraPosition;
     class ControllableEntity;
+    class EffectContainer;
     class ExplosionChunk;
     class MobileEntity;
@@ -163,4 +166,5 @@
     class TeamSpawnPoint;
     class WorldEntity;
+    class Rocket;
     // worldentities, pawns
     class Destroyer;
@@ -196,4 +200,5 @@
 typedef unsigned int ALuint;
 typedef int ALint;
+typedef int ALenum;
 
 #endif /* _OrxonoxPrereqs_H__ */
Index: code/branches/pickup2/src/orxonox/PlayerManager.cc
===================================================================
--- code/branches/pickup2/src/orxonox/PlayerManager.cc	(revision 6405)
+++ code/branches/pickup2/src/orxonox/PlayerManager.cc	(revision 6412)
@@ -38,5 +38,4 @@
 namespace orxonox
 {
-    PlayerManager* PlayerManager::singletonPtr_s = 0;
     ManageScopedSingleton(PlayerManager, ScopeID::Root, false);
 
@@ -92,4 +91,10 @@
     }
 
+    void PlayerManager::disconnectAllClients()
+    {
+        for( std::map<unsigned int, PlayerInfo*>::iterator it = this->clients_.begin(); it != this->clients_.end(); )
+            this->clientDisconnected( (it++)->first );
+    }
+
 
     PlayerInfo* PlayerManager::getClient(unsigned int clientID) const
Index: code/branches/pickup2/src/orxonox/PlayerManager.h
===================================================================
--- code/branches/pickup2/src/orxonox/PlayerManager.h	(revision 6405)
+++ code/branches/pickup2/src/orxonox/PlayerManager.h	(revision 6412)
@@ -52,4 +52,5 @@
             void clientConnected(unsigned int clientID);
             void clientDisconnected(unsigned int clientID);
+            void disconnectAllClients();
 
         private:
Index: code/branches/pickup2/src/orxonox/Radar.cc
===================================================================
--- code/branches/pickup2/src/orxonox/Radar.cc	(revision 6405)
+++ code/branches/pickup2/src/orxonox/Radar.cc	(revision 6412)
@@ -40,4 +40,6 @@
 #include "core/ObjectList.h"
 #include "interfaces/RadarListener.h"
+#include "controllers/HumanController.h"
+#include "worldentities/pawns/Pawn.h"
 
 namespace orxonox
@@ -45,5 +47,6 @@
 
     Radar::Radar()
-        : focus_(0)
+        : itFocus_(0)
+        , focus_(0)
         , objectTypeCounter_(0)
     {
@@ -82,5 +85,5 @@
     }
 
-    RadarViewable::Shape Radar::addObjectDescription(const std::string name)
+    RadarViewable::Shape Radar::addObjectDescription(const std::string& name)
     {
         std::map<std::string, RadarViewable::Shape>::iterator it = this->objectTypes_.find(name);
@@ -118,5 +121,5 @@
     void Radar::cycleFocus()
     {
-        if (ObjectList<RadarViewable>::begin() == 0)
+        if (ObjectList<RadarViewable>::begin() == ObjectList<RadarViewable>::end())
         {
             // list is empty
@@ -124,13 +127,13 @@
             this->focus_ = 0;
         }
-/*
-        else if (this->owner_)
+
+        else if (HumanController::getLocalControllerEntityAsPawn())
         {
-            Vector3 localPosition = this->owner_->getPosition();
+            Vector3 localPosition = HumanController::getLocalControllerEntityAsPawn()->getWorldPosition();
             Vector3 targetPosition = localPosition;
-            if (*(this->itFocus_))
+            if (this->itFocus_ && *(this->itFocus_))
                 targetPosition = this->itFocus_->getRVWorldPosition();
 
-            // find the closed object further away than targetPosition
+            // find the closest object further away than targetPosition
             float currentDistance = localPosition.squaredDistance(targetPosition);
             float nextDistance = FLT_MAX;
@@ -140,5 +143,5 @@
             for (ObjectList<RadarViewable>::iterator it = ObjectList<RadarViewable>::begin(); it; ++it)
             {
-                if (*it == static_cast<RadarViewable*>(this)->owner_)
+                if (*it == static_cast<RadarViewable*>(HumanController::getLocalControllerEntityAsPawn()))
                     continue;
 
@@ -167,5 +170,4 @@
             }
         }
-*/
     }
 
Index: code/branches/pickup2/src/orxonox/Radar.h
===================================================================
--- code/branches/pickup2/src/orxonox/Radar.h	(revision 6405)
+++ code/branches/pickup2/src/orxonox/Radar.h	(revision 6412)
@@ -55,5 +55,5 @@
 
         const RadarViewable* getFocus();
-        RadarViewable::Shape addObjectDescription(const std::string name);
+        RadarViewable::Shape addObjectDescription(const std::string& name);
 
         void listObjects() const;
Index: code/branches/pickup2/src/orxonox/Scene.cc
===================================================================
--- code/branches/pickup2/src/orxonox/Scene.cc	(revision 6405)
+++ code/branches/pickup2/src/orxonox/Scene.cc	(revision 6412)
@@ -58,4 +58,5 @@
         this->setScene(SmartPtr<Scene>(this, false), OBJECTID_UNKNOWN);
         this->bShadows_ = true;
+        this->soundReferenceDistance_ = 20.0;
 
         if (GameMode::showsGraphics())
@@ -113,4 +114,5 @@
         XMLPortParam(Scene, "ambientlight", setAmbientLight, getAmbientLight, xmlelement, mode).defaultValues(ColourValue(0.2f, 0.2f, 0.2f, 1.0f));
         XMLPortParam(Scene, "shadow", setShadow, getShadow, xmlelement, mode).defaultValues(true);
+        XMLPortParam(Scene, "soundReferenceDistance", setSoundReferenceDistance, getSoundReferenceDistance, xmlelement, mode);
 
         XMLPortParam(Scene, "gravity", setGravity, getGravity, xmlelement, mode);
@@ -334,18 +336,12 @@
     {
         // get the WorldEntity pointers
-        WorldEntity* object0 = static_cast<WorldEntity*>(colObj0->getUserPointer());
-        assert(orxonox_cast<WorldEntity*>(object0));
-        WorldEntity* object1 = static_cast<WorldEntity*>(colObj1->getUserPointer());
-        assert(orxonox_cast<WorldEntity*>(object1));
+        SmartPtr<WorldEntity> object0 = static_cast<WorldEntity*>(colObj0->getUserPointer());
+        SmartPtr<WorldEntity> object1 = static_cast<WorldEntity*>(colObj1->getUserPointer());
 
         // false means that bullet will assume we didn't modify the contact
         bool modified = false;
         if (object0->isCollisionCallbackActive())
-        {
             modified |= object0->collidesAgainst(object1, cp);
-            if (object1->isCollisionCallbackActive())
-                modified |= object1->collidesAgainst(object0, cp);
-        }
-        else
+        if (object1->isCollisionCallbackActive())
             modified |= object1->collidesAgainst(object0, cp);
 
Index: code/branches/pickup2/src/orxonox/Scene.h
===================================================================
--- code/branches/pickup2/src/orxonox/Scene.h	(revision 6405)
+++ code/branches/pickup2/src/orxonox/Scene.h	(revision 6412)
@@ -71,7 +71,12 @@
                 { return this->bShadows_; }
 
+            inline void setSoundReferenceDistance(float distance)
+                { this->soundReferenceDistance_ = distance; }
+            inline float getSoundReferenceDistance() const
+                { return this->soundReferenceDistance_; }
+
             inline Radar* getRadar()
                 { return this->radar_; }
-            
+
             inline virtual uint32_t getSceneID() const { return this->getObjectID(); }
 
@@ -96,4 +101,5 @@
             std::list<BaseObject*>   objects_;
             bool                     bShadows_;
+            float                    soundReferenceDistance_;
             Radar*                   radar_;
 
Index: code/branches/pickup2/src/orxonox/Test.cc
===================================================================
--- code/branches/pickup2/src/orxonox/Test.cc	(revision 6405)
+++ code/branches/pickup2/src/orxonox/Test.cc	(revision 6412)
@@ -36,12 +36,12 @@
 namespace orxonox
 {
-	CreateFactory ( Test );
+    CreateFactory ( Test );
   
-  SetConsoleCommand(Test, printV1, true).accessLevel(AccessLevel::User);
-  SetConsoleCommand(Test, printV2, true).accessLevel(AccessLevel::User);
-  SetConsoleCommand(Test, printV3, true).accessLevel(AccessLevel::User);
-  SetConsoleCommand(Test, printV4, true).accessLevel(AccessLevel::User);
-  SetConsoleCommand(Test, call, true).accessLevel(AccessLevel::User);
-  SetConsoleCommand(Test, call2, true).accessLevel(AccessLevel::User);
+    SetConsoleCommand(Test, printV1, true).accessLevel(AccessLevel::User);
+    SetConsoleCommand(Test, printV2, true).accessLevel(AccessLevel::User);
+    SetConsoleCommand(Test, printV3, true).accessLevel(AccessLevel::User);
+    SetConsoleCommand(Test, printV4, true).accessLevel(AccessLevel::User);
+    SetConsoleCommand(Test, call, true).accessLevel(AccessLevel::User);
+    SetConsoleCommand(Test, call2, true).accessLevel(AccessLevel::User);
   
   
@@ -50,96 +50,101 @@
 //   NetworkFunctionBase* NETWORK_FUNCTION_TEST_C = new NetworkFunctionStatic( createFunctor(&Test::printV1), "bla", NETWORK_FUNCTION_POINTER );
   
-  registerStaticNetworkFunction( &Test::printV1 );
-  registerMemberNetworkFunction( Test, checkU1 );
-  registerMemberNetworkFunction( Test, printBlaBla );
+    registerStaticNetworkFunction( &Test::printV1 );
+    registerMemberNetworkFunction( Test, checkU1 );
+    registerMemberNetworkFunction( Test, printBlaBla );
   
-  Test* Test::instance_ = 0;
+    Test* Test::instance_ = 0;
 
-	Test::Test(BaseObject* creator) : BaseObject(creator), Synchronisable(creator)
-	{
-    assert(instance_==0);
-    instance_=this;
-		RegisterObject ( Test );
-    setConfigValues();
-    registerVariables();
-		setSyncMode(0x3);
-	}
+    Test::Test(BaseObject* creator) : BaseObject(creator), Synchronisable(creator)
+    {
+        assert(instance_==0);
+        instance_=this;
+        RegisterObject ( Test );
+        setConfigValues();
+        registerVariables();
+        setSyncMode(0x3);
+        this->pointer_ = 0;
+    }
 
-	Test::~Test()
-	{
-    instance_=0;
-	}
+    Test::~Test()
+    {
+        instance_=0;
+    }
 
-	void Test::setConfigValues()
-	{
-		SetConfigValue ( u1, 1 )/*.callback ( this, &Test::checkV1 )*/;
-    SetConfigValue ( u2, 2 )/*.callback ( this, &Test::checkV2 )*/;
-    SetConfigValue ( u3, 3 )/*.callback ( this, &Test::checkV3 )*/;
-    SetConfigValue ( u4, 4 )/*.callback ( this, &Test::checkV4 )*/;
+    void Test::setConfigValues()
+    {
+        SetConfigValue ( u1, 1 )/*.callback ( this, &Test::checkV1 )*/;
+        SetConfigValue ( u2, 2 )/*.callback ( this, &Test::checkV2 )*/;
+        SetConfigValue ( u3, 3 )/*.callback ( this, &Test::checkV3 )*/;
+        SetConfigValue ( u4, 4 )/*.callback ( this, &Test::checkV4 )*/;
     
-    SetConfigValue ( s1, 1 )/*.callback ( this, &Test::checkV1 )*/;
-    SetConfigValue ( s2, 2 )/*.callback ( this, &Test::checkV2 )*/;
-    SetConfigValue ( s3, 3 )/*.callback ( this, &Test::checkV3 )*/;
-    SetConfigValue ( s4, 4 )/*.callback ( this, &Test::checkV4 )*/;
-	}
+        SetConfigValue ( s1, 1 )/*.callback ( this, &Test::checkV1 )*/;
+        SetConfigValue ( s2, 2 )/*.callback ( this, &Test::checkV2 )*/;
+        SetConfigValue ( s3, 3 )/*.callback ( this, &Test::checkV3 )*/;
+        SetConfigValue ( s4, 4 )/*.callback ( this, &Test::checkV4 )*/;
+    }
 
 
-  void Test::registerVariables()
-  {
-    registerVariable ( u1, variableDirection::toclient, new NetworkCallback<Test> ( this, &Test::checkU1 ));
-    registerVariable ( u2, variableDirection::toserver, new NetworkCallback<Test> ( this, &Test::checkU2 ));
-    registerVariable ( u3, variableDirection::serverMaster, new NetworkCallback<Test> ( this, &Test::checkU3 ), true );
-    registerVariable ( u4, variableDirection::clientMaster, new NetworkCallback<Test> ( this, &Test::checkU4 ), true );
+    void Test::registerVariables()
+    {
+        registerVariable ( u1, VariableDirection::ToClient, new NetworkCallback<Test> ( this, &Test::checkU1 ));
+        registerVariable ( u2, VariableDirection::ToServer, new NetworkCallback<Test> ( this, &Test::checkU2 ));
+        registerVariable ( u3, Bidirectionality::ServerMaster, new NetworkCallback<Test> ( this, &Test::checkU3 ), true );
+        registerVariable ( u4, Bidirectionality::ClientMaster, new NetworkCallback<Test> ( this, &Test::checkU4 ), true );
     
-    registerVariable ( s1, variableDirection::toclient, new NetworkCallback<Test> ( this, &Test::checkS1 ));
-    registerVariable ( s2, variableDirection::toserver, new NetworkCallback<Test> ( this, &Test::checkS2 ));
-    registerVariable ( s3, variableDirection::serverMaster, new NetworkCallback<Test> ( this, &Test::checkS3 ), true );
-    registerVariable ( s4, variableDirection::clientMaster, new NetworkCallback<Test> ( this, &Test::checkS4 ), true );
-  }
+        registerVariable ( s1, VariableDirection::ToClient, new NetworkCallback<Test> ( this, &Test::checkS1 ));
+        registerVariable ( s2, VariableDirection::ToServer, new NetworkCallback<Test> ( this, &Test::checkS2 ));
+        registerVariable ( s3, Bidirectionality::ServerMaster, new NetworkCallback<Test> ( this, &Test::checkS3 ), true );
+        registerVariable ( s4, Bidirectionality::ClientMaster, new NetworkCallback<Test> ( this, &Test::checkS4 ), true );
+    
+        registerVariable ( pointer_, VariableDirection::ToClient, new NetworkCallback<Test> ( this, &Test::printPointer ) );
+    }
   
   void Test::call(unsigned int clientID)
-  {
-    callStaticNetworkFunction( &Test::printV1, clientID );
-    callStaticNetworkFunction( &Test::printV1, clientID );
-  }
+    {
+        callStaticNetworkFunction( &Test::printV1, clientID );
+        callStaticNetworkFunction( &Test::printV1, clientID );
+    }
   
-  void Test::call2(unsigned int clientID, std::string s1, std::string s2, std::string s3, std::string s4)
-  {
-    callMemberNetworkFunction( Test, printBlaBla, this->getObjectID(), clientID, s1, s2, s3, s4, s4 );
-  }
+    void Test::call2(unsigned int clientID, std::string s1, std::string s2, std::string s3, std::string s4)
+    {
+        callMemberNetworkFunction( Test, printBlaBla, this->getObjectID(), clientID, s1, s2, s3, s4, s4 );
+    }
   
-  void Test::tick(float dt)
-  {
-//     std::string str1 = "blub";
-//     //MultiType mt1(std::string("blub"));
-//     MultiType mt1(str1);
-//     uint8_t* mem = new uint8_t[mt1.getNetworkSize()];
-//     uint8_t* temp = mem;
-//     mt1.exportData( temp );
-//     assert( temp-mem == mt1.getNetworkSize() );
-//     MultiType mt2;
-//     temp = mem;
-//     mt2.importData( temp );
-//     assert( temp-mem == mt1.getNetworkSize() );
-//     COUT(0) << mt2 << endl;
-    if(!Core::isMaster())
-      call2(0, "bal", "a", "n", "ce");
-//       callMemberNetworkFunction( Test, checkU1, this->getObjectID(), 0 );
-  }
-  
-  void Test::printBlaBla(std::string s1, std::string s2, std::string s3, std::string s4, std::string s5)
-  {
-    COUT(0) << s1 << s2 << s3 << s4 << s5 << endl;
-  }
-  
-  void Test::checkU1(){ COUT(1) << "U1 changed: " << u1 << std::endl; }
-  void Test::checkU2(){ COUT(1) << "U2 changed: " << u2 << std::endl; }
-  void Test::checkU3(){ COUT(1) << "U3 changed: " << u3 << std::endl; }
-  void Test::checkU4(){ COUT(1) << "U4 changed: " << u4 << std::endl; }
+    void Test::tick(float dt)
+    {
+    //     std::string str1 = "blub";
+    //     //MultiType mt1(std::string("blub"));
+    //     MultiType mt1(str1);
+    //     uint8_t* mem = new uint8_t[mt1.getNetworkSize()];
+    //     uint8_t* temp = mem;
+    //     mt1.exportData( temp );
+    //     assert( temp-mem == mt1.getNetworkSize() );
+    //     MultiType mt2;
+    //     temp = mem;
+    //     mt2.importData( temp );
+    //     assert( temp-mem == mt1.getNetworkSize() );
+    //     COUT(0) << mt2 << endl;
+    //     if(!Core::isMaster())
+    //       call2(0, "bal", "a", "n", "ce");
+    //       callMemberNetworkFunction( Test, checkU1, this->getObjectID(), 0 );
+    }
+    
+    void Test::printBlaBla(std::string s1, std::string s2, std::string s3, std::string s4, std::string s5)
+    {
+        COUT(0) << s1 << s2 << s3 << s4 << s5 << endl;
+    }
+    
+    void Test::checkU1(){ COUT(1) << "U1 changed: " << u1 << std::endl; }
+    void Test::checkU2(){ COUT(1) << "U2 changed: " << u2 << std::endl; }
+    void Test::checkU3(){ COUT(1) << "U3 changed: " << u3 << std::endl; }
+    void Test::checkU4(){ COUT(1) << "U4 changed: " << u4 << std::endl; }
 
-  void Test::checkS1(){ COUT(1) << "S1 changed: " << s1 << std::endl; }
-  void Test::checkS2(){ COUT(1) << "S2 changed: " << s2 << std::endl; }
-  void Test::checkS3(){ COUT(1) << "S3 changed: " << s3 << std::endl; }
-  void Test::checkS4(){ COUT(1) << "S4 changed: " << s4 << std::endl; }
+    void Test::checkS1(){ COUT(1) << "S1 changed: " << s1 << std::endl; }
+    void Test::checkS2(){ COUT(1) << "S2 changed: " << s2 << std::endl; }
+    void Test::checkS3(){ COUT(1) << "S3 changed: " << s3 << std::endl; }
+    void Test::checkS4(){ COUT(1) << "S4 changed: " << s4 << std::endl; }
+    
+    void Test::printPointer(){ CCOUT(1) << "pointer: " << this->pointer_ << endl; }
 
 }
Index: code/branches/pickup2/src/orxonox/Test.h
===================================================================
--- code/branches/pickup2/src/orxonox/Test.h	(revision 6405)
+++ code/branches/pickup2/src/orxonox/Test.h	(revision 6412)
@@ -76,4 +76,6 @@
       void checkS4();
 
+      void printPointer();
+
       static void printV1(){ instance_->checkU1(); }
       static void printV2(){ instance_->checkU2(); }
@@ -94,4 +96,6 @@
       TYPE s4;
 
+      Test* pointer_;
+
       static Test* instance_;
   };
Index: code/branches/pickup2/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- code/branches/pickup2/src/orxonox/controllers/ArtificialController.cc	(revision 6405)
+++ code/branches/pickup2/src/orxonox/controllers/ArtificialController.cc	(revision 6412)
@@ -46,5 +46,5 @@
         this->bHasTargetPosition_ = false;
         this->targetPosition_ = Vector3::ZERO;
-        
+
         this->target_.setCallback(createFunctor(&ArtificialController::targetDied, this));
     }
@@ -143,4 +143,8 @@
         this->targetPosition_ = getPredictedPosition(this->getControllableEntity()->getPosition(), hardcoded_projectile_speed, this->target_->getPosition(), this->target_->getVelocity());
         this->bHasTargetPosition_ = (this->targetPosition_ != Vector3::ZERO);
+
+        Pawn* pawn = dynamic_cast<Pawn*>(this->getControllableEntity());
+        if (pawn)
+            pawn->setAimPosition(this->targetPosition_);
     }
 
